import 'package:flutter/foundation.dart';
import 'package:flutter/services.dart';

import 'numetagen_sdk_flutter_platform_interface.dart';

/// An implementation of [NumetagenFlutterSdkPlatform] that uses method channels.
class MethodChannelNumetagenFlutterSdk extends NumetagenFlutterSdkPlatform {
  /// The method channel used to interact with the native platform.
  @visibleForTesting
  final methodChannel = const MethodChannel('numetagen_flutter_sdk');

  /// The method channel used to open the native platform.
  @override
  Future<String?> startAdsActivity() async {
    return await methodChannel.invokeMethod<String>('startAdsActivity');
  }
}
