import 'package:plugin_platform_interface/plugin_platform_interface.dart';

import 'numetagen_sdk_flutter_method_channel.dart';

abstract class NumetagenFlutterSdkPlatform extends PlatformInterface {
  /// Constructs a NumetagenFlutterSdkPlatform.
  NumetagenFlutterSdkPlatform() : super(token: _token);

  static final Object _token = Object();

  static NumetagenFlutterSdkPlatform _instance =
      MethodChannelNumetagenFlutterSdk();

  /// The default instance of [NumetagenFlutterSdkPlatform] to use.
  ///
  /// Defaults to [MethodChannelNumetagenFlutterSdk].
  static NumetagenFlutterSdkPlatform get instance => _instance;

  /// Platform-specific implementations should set this with their own
  /// platform-specific class that extends [NumetagenFlutterSdkPlatform] when
  /// they register themselves.
  static set instance(NumetagenFlutterSdkPlatform instance) {
    PlatformInterface.verifyToken(instance, _token);
    _instance = instance;
  }

  /// Starts the ads activity.
  Future<String?> startAdsActivity() {
    throw UnimplementedError('startAdsActivity() has not been implemented.');
  }
}
